;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: PWMDB16_1.asm
;;   Version: 2.5, Updated on 2008/6/23 at 12:25:32
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION: PWMDB16 User Module software implementation file
;;               for the 22/24/27/29xxx PSoC family of devices
;;
;;  NOTE: User Module APIs conform to the fastcall16 convention for marshalling
;;        arguments and observe the associated "Registers are volatile" policy.
;;        This means it is the caller's responsibility to preserve any values
;;        in the X and A registers that are still needed after the API functions
;;        returns. For Large Memory Model devices it is also the caller's 
;;        responsibility to perserve any value in the CUR_PP, IDX_PP, MVR_PP and 
;;        MVW_PP registers. Even though some of these registers may not be modified
;;        now, there is no guarantee that will remain the case in future releases.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "PWMDB16_1.inc"
include "m8c.inc"
include "memory.inc"

;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export    PWMDB16_1_EnableInt
export   _PWMDB16_1_EnableInt
export    PWMDB16_1_DisableInt
export   _PWMDB16_1_DisableInt
export    PWMDB16_1_Start
export   _PWMDB16_1_Start
export    PWMDB16_1_Stop
export   _PWMDB16_1_Stop
export    PWMDB16_1_WritePeriod
export   _PWMDB16_1_WritePeriod
export    PWMDB16_1_WritePulseWidth
export   _PWMDB16_1_WritePulseWidth
export    PWMDB16_1_WriteDeadTime
export   _PWMDB16_1_WriteDeadTime
export    PWMDB16_1_wReadPulseWidth
export   _PWMDB16_1_wReadPulseWidth

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       WARNING WARNING WARNING
; The following exports are for backwards
; compatibility only and should not be used
; for new designs.
export    wPWMDB16_1_ReadPulseWidth
export   _wPWMDB16_1_ReadPulseWidth
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;-----------------------------------------------
;  Constant Definitions
;-----------------------------------------------

bfCONTROL_REG_START_BIT:   equ   1  ; Control register start bit

AREA UserModules (ROM, REL)

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: PWMDB16_1_EnableInt
;
;  DESCRIPTION:
;     Enables this PWM's interrupt by setting the interrupt enable mask bit
;     associated with this User Module. Remember to call the global interrupt
;     enable function by using the macro: M8C_EnableGInt.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: None
;
;  RETURNS:  None
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 PWMDB16_1_EnableInt:
_PWMDB16_1_EnableInt:
   RAM_PROLOGUE RAM_USE_CLASS_1
   M8C_EnableIntMask PWMDB16_1_INT_REG, PWMDB16_1_bINT_MASK
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: PWMDB16_1_DisableInt
;
;  DESCRIPTION:
;     Disables this PWM's interrupt by clearing the interrupt enable mask bit
;     associated with this User Module.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: None
;
;  RETURNS:  None
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 PWMDB16_1_DisableInt:
_PWMDB16_1_DisableInt:
   RAM_PROLOGUE RAM_USE_CLASS_1
   M8C_DisableIntMask  PWMDB16_1_INT_REG, PWMDB16_1_bINT_MASK
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: PWMDB16_1_Start
;
;  DESCRIPTION:
;     Sets the start bits in the Control registers of this user module.  The
;     PWM will begin counting on the next input clock as soon as the
;     enable input is asserted high.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: None
;
;  RETURNS: None
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 PWMDB16_1_Start:
_PWMDB16_1_Start:
   RAM_PROLOGUE RAM_USE_CLASS_1
   or    REG[PWMDB16_1_PWM_CONTROL_LSB_REG], bfCONTROL_REG_START_BIT
   or    REG[PWMDB16_1_DB_CONTROL_REG], bfCONTROL_REG_START_BIT
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: PWMDB16_1_Stop
;
;  DESCRIPTION:
;     Disables PWM operation.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: None
;
;  RETURNS: None
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
;    After this function completes:
;       1) The PWM Counter register will latch any data written to the Period
;          register
;       2) The DB Counter register will latch any data written to the DeadTime
;          Counter register.
;
 PWMDB16_1_Stop:
_PWMDB16_1_Stop:
   RAM_PROLOGUE RAM_USE_CLASS_1
   and   REG[PWMDB16_1_PWM_CONTROL_LSB_REG], ~bfCONTROL_REG_START_BIT
   and   REG[PWMDB16_1_DB_CONTROL_REG], ~bfCONTROL_REG_START_BIT
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: PWMDB16_1_WritePeriod
;
;  DESCRIPTION:
;     Write the period value into the Period register.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;     WORD  wPeriodValue - period count -
;              MSB passed in X register
;              LSB passed in A register
;
;  RETURNS: None
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
;    If the PWM user module is stopped, then this value will also be
;    latched into the Counter registers.
;
 PWMDB16_1_WritePeriod:
_PWMDB16_1_WritePeriod:
   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   REG[PWMDB16_1_PWM_PERIOD_LSB_REG], A
   mov   A, X
   mov   REG[PWMDB16_1_PWM_PERIOD_MSB_REG], A
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: PWMDB16_1_WritePulseWidth
;
;  DESCRIPTION:
;     Writes pulse width value into the PulseWidth register.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;     WORD  wPulseWidth - compare value count -
;              MSB passed in X register
;              LSB passed in A register
;
;  RETURNS: None
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 PWMDB16_1_WritePulseWidth:
_PWMDB16_1_WritePulseWidth:
   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   REG[PWMDB16_1_PULSE_WIDTH_LSB_REG], A
   mov   A, X
   mov   REG[PWMDB16_1_PULSE_WIDTH_MSB_REG], A
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: PWMDB16_1_WriteDeadTime
;
;  DESCRIPTION:
;     Writes Dead Time counter value into the DeadTimeCounter register.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;     BYTE  bDeadTime - dead time counter value count - passed in Accumulator.
;
;  RETURNS: None
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 PWMDB16_1_WriteDeadTime:
_PWMDB16_1_WriteDeadTime:
   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   REG[PWMDB16_1_DEAD_TIME_REG], A
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: PWMDB16_1_wReadPulseWidth
;
;  DESCRIPTION:
;     Reads the PulseWidth registers.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  None
;
;  RETURNS:
;     WORD  wPulseWidth - value read from PulseWidth register -
;           LSB returned in A register
;           MSB returned in X register
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 PWMDB16_1_wReadPulseWidth:
_PWMDB16_1_wReadPulseWidth:
 wPWMDB16_1_ReadPulseWidth:  ; Do not use! For backwards compatibility only.
_wPWMDB16_1_ReadPulseWidth:  ; Do not use! For backwards compatibility only.
   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   A, REG[PWMDB16_1_PULSE_WIDTH_MSB_REG]
   mov   X, A
   mov   A, REG[PWMDB16_1_PULSE_WIDTH_LSB_REG]
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

; End of File PWMDB16_1.asm

